#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
#  Copyright(c)  2005  Richard B. Johnson
#
#  This program may be distributed under the GNU Public License
#  version 2, as published by the Free Software Foundation, Inc.,
#  59 Temple Place, Suite 330 Boston, MA, 02111.
#
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
#  This is for the system error messages.
#  Created 02-APR-2005   Richard B. Johnson  RichardBJohnson@comcast.net
#
#  Note! I know that this is just "a few lines of 'C'". Don't do it!
#  it will be much, much larger!
#
.section        .rodata
.include        "errors.s"
.section        .text
#
#       This returns a pointer to the error text, given some
#       'errno' input. This is range-checked and will return
#       a pointer to "Unknown error" if it's out-of-range.
#
strerror:
        movl    0x04(%esp), %eax        # Get error-code
        shll    $2, %eax                # Times sizeof(pointer)
        addl    $sys_errlist, %eax      # Offset to start of table
        cmpl    $sys_err_end, %eax      # Check limits
        jbe     1f                      # It's okay
        movl    $sys_err_end, %eax      # Set max limit
1:      movl    (%eax), %eax            # de-reference pointer
        ret
.size   strerror,.-strerror
.type   strerror,@function
.global strerror
.end

