//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
// File: chk_malloc.c   Created 10-OCT-2002     Richard B. Johnson
//
//

#include <stdio.h>
#include <malloc.h>
#include <signal.h>

extern void exit(int);

void trap(int sig)
{
    fprintf(stderr, "Received signal %d\n", sig);
   (void)signal(SIGSEGV, SIG_IGN);
   exit(1);
}

int main(void);
int main()
{
   unsigned char *ptr;
   (void)signal(SIGSEGV, trap);
   ptr = malloc(0);
   printf("malloc(0) returned %p\n", ptr);
   printf("Free it\n");
   free(ptr);
   printf("Okay\n");
   ptr = calloc(1, 0);
   printf("calloc(1,0) returned %p\n", ptr);
   printf("Free it\n");
   free(ptr);
   ptr = malloc(0);
   printf("malloc(0) returned %p\n", ptr);
   ptr = realloc(ptr, 10);
   printf("realloc(10) returned %p\n", ptr);
   printf("Try to write to it...\n");
   *ptr = 0x00;
   printf("Okay\n");
   printf("Free it\n");
   free(ptr);
   ptr = malloc(0);
   printf("malloc(0) returned %p\n", ptr);
   printf("Try to write to it...\n");
   *ptr = 0x00;

   return 0;
}


