

.section        .bss
.comm           Q,4096,32

.section        .data
a:              .long   -1082263718
a1:             .long   22
c:              .long   362436
c1:             .long   0
i:              .long   1023
.section        .text

#
#
#static unsigned long Q[1024];
#
#unsigned long CMWC()
#{
#    unsigned long long t;
#    unsigned long long a = 123471787866LL;
#    static unsigned long c = 362436;
#    static unsigned long i = 1023;
#    unsigned long x;
#    unsigned long r = 0xfffffffe;
#    i = (i + 1) & 0x03ff;
#    t = (a * Q[i]) + c;
#    c = (t >> 32);
#    x = t + c;
#    if(x < c)
#    {
#        x++;
#        c++;
#    }
#    return (Q[i] = r - x);
#}
#
.global CMWC
.type   CMWC,@function
CMWC:   movl    (i), %ebx       # Get i
        incl    %ebx            # i++
        andl    $0x03f, %ebx    # i &= 0x3f
        movl    %ebx, (i)       # Save new i
        movl    (%ebx), %ecx    # Got Q[i] into ecx
        movl    (a), %eax       # Get low word
        mul     %ecx            # Result in EDX:EAX
        movl    %eax, (a)       # Replace low word
        addl    (a1), %edx      # CY plus old high word
        movl    %edx, %eax      # Into accumulator
        mul     %ecx            # Multiply high word
        movl    %eax, (a1)      # Replace high word
        movl    (a), %eax       # Get low word again
        movl    (a1), %edx      # Get logh word
        addl    (c), %eax       # Low word
        adcl    (c1), %edx      # EDX:EAX = t;
        movl    %edx, (c)       # c = t >> 32;
        movl    $0, (c1)        # High word of c



        ret


#
#void make_seeds()
#{
#    unsigned long j = 12345678;
#    size_t i;
#    for(i=0; i< 1024; i++)
#    {
#        j ^= (j << 13);
#        j ^= (j >> 17);
#        j ^= (j << 5);
#        Q[i] = j;
#    }
#}

#
#       This makes the initial table of seeds for the RNG
#

.global make_seeds
.type   make_seeds,@function
make_seeds:
        pushl   %ebx                    # Save index register
        movl    $Q, %ebx                # Point to the array
        movl    $12345678, %eax         # This will be 'j'
        movl    $0x400, %ecx            # Loop counter
1:      movl    %eax, %edx              # Get copy of 'j'
        shll    $13, %edx               # Shift the copy left
        xorl    %edx, %eax              # Perform XOR
        movl    %eax, %edx              # Get new copy
        shrl    $17, %edx               # Shift the copy right
        xorl    %edx, %eax              # Perform the XOR
        movl    %eax, %edx              # Get new copy
        shll    $5, %edx                # Shift the copy left
        xorl    %edx, %eax              # Peform the XOR
        movl    %eax, (%ebx)            # Put into array
        leal    0x04(%ebx), %ebx        # Ready next location
        loop    1b                      # Continue
        popl    %ebx
        ret

