#include <stdio.h>


unsigned long Q[1024];

unsigned long CMWC()
{
    unsigned long long t;
    static unsigned long long a = 123471787866LL;
    static unsigned long c = 362436;
    static unsigned long i = 1023;
    unsigned long x;
    unsigned long r = 0xfffffffe;
    i = (i + 1) & 0x03ff;
    t = (a * Q[i]) + c;
    c = (t >> 32);
    x = t + c;
    if(x < c)
    {
        x++;
        c++;
    }
    return (Q[i] = r - x);
}
void xmake_seeds()
{
    unsigned long j = 12345678;
    size_t i;
    for(i=0; i< 1024; i++)
    {
        j ^= (j << 13);
        j ^= (j >> 17);
        j ^= (j << 5);
        Q[i] = j;
    }
}

extern void make_seeds(void);

int main()
{
    char buf[34];
    size_t i, j;
    long x;
    xmake_seeds();
    printf("%08lx\n", CMWC());
//    exit(0);
    for(;;)
    {
//         printf("%08x\n", CMWC());
        x = CMWC();
        for(i = 0, j = 0x80000000; i< 32; i++, j >>=1)
           if(x & j)
               buf[i] = (char) '1';
           else
               buf[i] = (char) '0';
        buf[i] = 0x00;
        puts(buf);
    }
    return 0;
}

