//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <fcntl.h>
#include <unistd.h>

static char internal[L_tmpnam];

char *tmpnam(char *s)
{
    int fd;
    uint32_t tmp;
    if(s == NULL)
        s = internal;
    if((fd = open("/dev/urandom", O_RDONLY)) != -1)
    {
        (void)read(fd, &tmp, sizeof(tmp));
        (void)close(fd);
    }
    else
        tmp = rand();
    sprintf(s, "%s/%08x", P_tmpdir, tmp);
    return s;
}
