//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#include <sys/timeb.h>
#include <sys/time.h>

int ftime(struct timeb *timebuf)
{
        struct timeval tv;
        struct timezone tz;

        if (gettimeofday (&tv, &tz) < 0)
                return -1;

        timebuf->time    = tv.tv_sec;
        timebuf->millitm = (tv.tv_usec + 999) / 1000;
        timebuf->timezone = tz.tz_minuteswest;
        timebuf->dstflag = tz.tz_dsttime;
        return 0;
}
