//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//  Created 16-MAY-2005 Richard B. Johnson      RichardBJohnson@comcast.net
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#include <stdlib.h>
#include <errno.h>
#include <linux/auxvec.h>

#define LAST AT_CLKTCK

struct AUXV {                           // Private structure
    unsigned long ident;                // Ident from elf.h
    unsigned long value;                // System specific value
    };

extern struct AUXV *__auxv;             // It's in start.S
extern void __set_errno(int);           // It's in lowlevel.S

int getpagesize()
{
    size_t i;
    for(i=0; i < LAST; i++)
        if(__auxv[i].ident == AT_PAGESZ)
            return __auxv[i].value;
   __set_errno(ENOSYS);
   return -1;
}
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
