//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#include <stdio.h>
#include <stdlib.h>

extern char *makeascii(char *buf, long long value, int base);

#define MAX_LL 1000000000000000000

char *fp_string(char *buf, char *end, double num,
                int unused, int size, int precision, int type)
{

    long long int_part;
    do {
        int_part = (long long) num;
        num -= (double) int_part;
        buf = makeascii(buf, int_part, 10);
       } while (int_part);
       *buf++ = (char) '.';
    while(precision--)
        num *= (double) 10;
    do {
        int_part = (long long) num;
        num -= (double) int_part;
        buf = makeascii(buf, int_part, 10);
       } while (int_part);
    return buf;
}


int main()
{
    char buf[0x10000];
    double x = 12345678901234.5678900000000000;
    fp_string(buf, NULL, x, 0, 10, 8, 0);
    puts(buf);
    return 0;

}

