#!/bin/bash
#
#	This looks at <ctype.h> and tries to determine if
#	use use global or local ctype arrays.
#
TMPF=/tmp/checker

cat >${TMPF}.c <<EOF
#include <stdio.h>
#include <ctype.h>
const unsigned short int *sp;
int main(void);
int main()
{
    sp = __ctype_b;
    return 0;
}
EOF
if  gcc -o ${TMPF} ${TMPF}.c 2>/dev/null ; then
    echo -DUSE_GLOBAL >local.cfg
else
    echo -DUSE_LOCAL >local.cfg
fi
rm -f ${TMPF} ${TMPF}.c


 
