//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//   File: makerrors.c  Created 12-MAY-2004             Richard B. Johnson
//   This program builds up an array of strings and an array of pointers
//   to those strings to create global sys_errlist.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#include <stdio.h>
#include <string.h>
#include <errno.h>
int main(void);
int main()
{
    const char *cp, *xp;
    int i, len;
    xp = NULL;
    for(i=0; i<200; i++)
    {
        cp = strerror(i);
        if(cp == xp)
            break;
        xp = cp;
    }
    len = i - 1;
    printf(".align\t0x04\n");
    printf("sys_errlist:\t.long\t.L%03d\n",0);
    for(i=1; i<len; i++)
        printf("\t\t.long\t.L%03d\n",i);
    printf("sys_err_end:\t.long\t.L%03d\n",i);
    printf(".size\tsys_errlist,.-sys_errlist\n");
    printf(".type\tsys_errlist,@object\n");
    printf(".global\tsys_errlist\n");
    for(i=0; i <len; i++)
    {
        cp = strerror(i);
        if(strlen(cp) & 1)
            printf(".L%03d:\t.string\t\"%s\"\n",i, cp); // Even after null
        else
            printf(".L%03d:\t.string\t\"%s\\0\"\n",i, cp);
        printf(".size\t.L%03d,.-.L%03d\n", i, i);
        printf(".type\t.L%03d,@object\n", i);
    }
    printf(".L%03d:\t.string\t\"%s >= %d\"\n",i, "Unknown error", i);
    printf(".size\t.L%03d,.-.L%03d\n", i, i);
    printf(".type\t.L%03d,@object\n", i);
    return 0;
}
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

