//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/*
 * This prints an "Assertion failed" message and aborts.
 */


void __assert_fail(const char *assn, const char *file, unsigned int line,
                                const char *funct)
{
    fprintf(stderr,"Assertion failed %s, file %s, line %u, function %s\n",
                    assn, file, line, funct);
    abort();

}
/*
 * Likewise, but prints the error text for ERRNUM.
 */
void __assert_perror_fail (int errnum, const char *file, unsigned int line,
                                       const char *funct)
{
    fprintf(stderr,"Assertion failed %s, file %s, line %u, function %s\n",
                    strerror(errnum), file, line, funct);
    abort();
}

